diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet-apps/model/ping6.cc ns-3.40/src/internet-apps/model/ping6.cc
--- ns-3.39/src/internet-apps/model/ping6.cc	2023-07-05 14:23:47.829427500 -0700
+++ ns-3.40/src/internet-apps/model/ping6.cc	2023-09-27 13:30:37.646839100 -0700
@@ -210,7 +210,7 @@
         size = 4;
     }
 
-    uint8_t* data = new uint8_t[size];
+    auto data = new uint8_t[size];
     memset(data, 0, size);
     data[0] = 0xDE;
     data[1] = 0xAD;
@@ -218,7 +218,7 @@
     data[3] = 0xEF;
 
     Ptr<Packet> p = Create<Packet>(data, size);
-    Icmpv6Echo req(1);
+    Icmpv6Echo req(true);
 
     req.SetId(0xBEEF);
     req.SetSeq(m_seq);
@@ -268,7 +268,7 @@
         if (Inet6SocketAddress::IsMatchingType(from))
         {
             Ipv6Header hdr;
-            Icmpv6Echo reply(0);
+            Icmpv6Echo reply(false);
             Icmpv6DestinationUnreachable destUnreach;
             Icmpv6TimeExceeded timeExceeded;
             Inet6SocketAddress address = Inet6SocketAddress::ConvertFrom(from);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet-apps/model/ping.cc ns-3.40/src/internet-apps/model/ping.cc
--- ns-3.39/src/internet-apps/model/ping.cc	2023-07-05 14:23:47.829427500 -0700
+++ ns-3.40/src/internet-apps/model/ping.cc	2023-09-27 13:30:37.646839100 -0700
@@ -206,7 +206,7 @@
                     NS_LOG_INFO("Packet too short, discarding");
                     return;
                 }
-                uint8_t* buf = new uint8_t[dataSize];
+                auto buf = new uint8_t[dataSize];
                 echo.GetData(buf);
                 uint64_t appSignature = Read64(buf);
                 delete[] buf;
@@ -286,7 +286,7 @@
             switch (type)
             {
             case Icmpv6Header::ICMPV6_ECHO_REPLY: {
-                Icmpv6Echo echo(0);
+                Icmpv6Echo echo(false);
                 packet->RemoveHeader(echo);
 
                 if (echo.GetId() != PING_ID)
@@ -305,7 +305,7 @@
                     NS_LOG_INFO("Packet too short, discarding");
                     return;
                 }
-                uint8_t* buf = new uint8_t[dataSize];
+                auto buf = new uint8_t[dataSize];
                 packet->CopyData(buf, dataSize);
                 uint64_t appSignature = Read64(buf);
                 delete[] buf;
@@ -426,7 +426,7 @@
     // (where any difference would show up anyway) and borrow that code.  Don't
     // be too surprised when you see that this is a little endian convention.
     //
-    uint8_t* data = new uint8_t[m_size];
+    auto data = new uint8_t[m_size];
     memset(data, 0, m_size);
     NS_ASSERT_MSG(m_size >= 16, "ECHO Payload size must be at least 16 bytes");
 
@@ -583,8 +583,7 @@
     {
         if (Ipv4Address::IsMatchingType(m_interfaceAddress))
         {
-            InetSocketAddress senderInet =
-                InetSocketAddress(Ipv4Address::ConvertFrom(m_interfaceAddress));
+            InetSocketAddress senderInet(Ipv4Address::ConvertFrom(m_interfaceAddress));
             int status = m_socket->Bind(senderInet);
             NS_ASSERT_MSG(status == 0, "Failed to bind IPv4 socket");
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet-apps/model/radvd.cc ns-3.40/src/internet-apps/model/radvd.cc
--- ns-3.39/src/internet-apps/model/radvd.cc	2023-07-05 14:23:47.829427500 -0700
+++ ns-3.40/src/internet-apps/model/radvd.cc	2023-09-27 13:30:37.650839000 -0700
@@ -75,7 +75,7 @@
 Radvd::~Radvd()
 {
     NS_LOG_FUNCTION(this);
-    for (RadvdInterfaceListI it = m_configurations.begin(); it != m_configurations.end(); ++it)
+    for (auto it = m_configurations.begin(); it != m_configurations.end(); ++it)
     {
         *it = nullptr;
     }
@@ -91,7 +91,7 @@
     m_recvSocket->Close();
     m_recvSocket = nullptr;
 
-    for (SocketMapI it = m_sendSockets.begin(); it != m_sendSockets.end(); ++it)
+    for (auto it = m_sendSockets.begin(); it != m_sendSockets.end(); ++it)
     {
         it->second->Close();
         it->second = nullptr;
@@ -120,7 +120,7 @@
         m_recvSocket->SetRecvPktInfo(true);
     }
 
-    for (RadvdInterfaceListCI it = m_configurations.begin(); it != m_configurations.end(); it++)
+    for (auto it = m_configurations.begin(); it != m_configurations.end(); it++)
     {
         if ((*it)->IsSendAdvert())
         {
@@ -159,13 +159,13 @@
         m_recvSocket->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
     }
 
-    for (EventIdMapI it = m_unsolicitedEventIds.begin(); it != m_unsolicitedEventIds.end(); ++it)
+    for (auto it = m_unsolicitedEventIds.begin(); it != m_unsolicitedEventIds.end(); ++it)
     {
         Simulator::Cancel((*it).second);
     }
     m_unsolicitedEventIds.clear();
 
-    for (EventIdMapI it = m_solicitedEventIds.begin(); it != m_solicitedEventIds.end(); ++it)
+    for (auto it = m_solicitedEventIds.begin(); it != m_solicitedEventIds.end(); ++it)
     {
         Simulator::Cancel((*it).second);
     }
@@ -231,8 +231,7 @@
     }
 
     /* add list of prefixes */
-    for (std::list<Ptr<RadvdPrefix>>::const_iterator jt = prefixes.begin(); jt != prefixes.end();
-         jt++)
+    for (auto jt = prefixes.begin(); jt != prefixes.end(); jt++)
     {
         uint8_t flags = 0;
         prefixHdr = Icmpv6OptionPrefixInformation();
@@ -288,7 +287,7 @@
 
     if (reschedule)
     {
-        uint64_t delay = static_cast<uint64_t>(
+        auto delay = static_cast<uint64_t>(
             m_jitter->GetValue(config->GetMinRtrAdvInterval(), config->GetMaxRtrAdvInterval()) +
             0.5);
         if (config->IsInitialRtrAdv())
@@ -348,9 +347,7 @@
                 NS_LOG_INFO("Received ICMPv6 Router Solicitation from "
                             << hdr.GetSource() << " code = " << (uint32_t)rsHdr.GetCode());
 
-                for (RadvdInterfaceListCI it = m_configurations.begin();
-                     it != m_configurations.end();
-                     it++)
+                for (auto it = m_configurations.begin(); it != m_configurations.end(); it++)
                 {
                     if (ipInterfaceIndex == (*it)->GetInterface())
                     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet-apps/model/radvd-interface.cc ns-3.40/src/internet-apps/model/radvd-interface.cc
--- ns-3.39/src/internet-apps/model/radvd-interface.cc	2023-07-05 14:23:47.829427500 -0700
+++ ns-3.40/src/internet-apps/model/radvd-interface.cc	2023-09-27 13:30:37.646839100 -0700
@@ -86,7 +86,7 @@
 {
     NS_LOG_FUNCTION(this);
     /* clear prefixes */
-    for (RadvdPrefixListI it = m_prefixes.begin(); it != m_prefixes.end(); ++it)
+    for (auto it = m_prefixes.begin(); it != m_prefixes.end(); ++it)
     {
         (*it) = nullptr;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet-apps/model/v4ping.cc ns-3.40/src/internet-apps/model/v4ping.cc
--- ns-3.39/src/internet-apps/model/v4ping.cc	2023-07-05 14:23:47.829427500 -0700
+++ ns-3.40/src/internet-apps/model/v4ping.cc	2023-09-27 13:30:37.650839000 -0700
@@ -137,11 +137,11 @@
         {
             Icmpv4Echo echo;
             p->RemoveHeader(echo);
-            std::map<uint16_t, Time>::iterator i = m_sent.find(echo.GetSequenceNumber());
+            auto i = m_sent.find(echo.GetSequenceNumber());
 
             if (i != m_sent.end() && echo.GetIdentifier() == 0)
             {
-                uint32_t* buf = new uint32_t[m_size];
+                auto buf = new uint32_t[m_size];
                 uint32_t dataSize = echo.GetDataSize();
                 uint32_t nodeId;
                 uint32_t appId;
@@ -215,7 +215,7 @@
     // (where any difference would show up anyway) and borrow that code.  Don't
     // be too surprised when you see that this is a little endian convention.
     //
-    uint8_t* data = new uint8_t[m_size];
+    auto data = new uint8_t[m_size];
     for (uint32_t i = 0; i < m_size; ++i)
     {
         data[i] = 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet-apps/model/v4traceroute.cc ns-3.40/src/internet-apps/model/v4traceroute.cc
--- ns-3.39/src/internet-apps/model/v4traceroute.cc	2023-07-05 14:23:47.829427500 -0700
+++ ns-3.40/src/internet-apps/model/v4traceroute.cc	2023-09-27 13:30:37.650839000 -0700
@@ -243,7 +243,7 @@
             recvSeq = (uint16_t)data[7] << 0;
             recvSeq |= (uint16_t)data[6] << 8;
 
-            std::map<uint16_t, Time>::iterator i = m_sent.find(recvSeq);
+            auto i = m_sent.find(recvSeq);
             if (i != m_sent.end())
             {
                 Time sendTime = i->second;
@@ -296,7 +296,7 @@
 
             Icmpv4Echo echo;
             p->RemoveHeader(echo);
-            std::map<uint16_t, Time>::iterator i = m_sent.find(echo.GetSequenceNumber());
+            auto i = m_sent.find(echo.GetSequenceNumber());
 
             if (i != m_sent.end() && echo.GetIdentifier() == 0)
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet-apps/test/ping-test.cc ns-3.40/src/internet-apps/test/ping-test.cc
--- ns-3.39/src/internet-apps/test/ping-test.cc	2023-07-05 14:23:47.829427500 -0700
+++ ns-3.40/src/internet-apps/test/ping-test.cc	2023-09-27 13:30:37.650839000 -0700
@@ -576,7 +576,7 @@
     //                        number sent equals number received, which equals 5.
     //    How validated:  PingReport trace is checked for number of packets
     //                    transmitted and received (5), and number of drops (0).
-    PingTestCase* testcase1v4 = new PingTestCase(
+    auto testcase1v4 = new PingTestCase(
         "1. Unlimited pings, no losses, StopApplication () with no packets in flight IPv4",
         USEIPV6_FALSE);
     testcase1v4->SetStartTime(Seconds(1));
@@ -588,7 +588,7 @@
     testcase1v4->SetDestinationAddress(Ipv4Address("10.0.0.2"));
     AddTestCase(testcase1v4, TestCase::QUICK);
 
-    PingTestCase* testcase1v6 = new PingTestCase(
+    auto testcase1v6 = new PingTestCase(
         "1. Unlimited pings, no losses, StopApplication () with no packets in flight IPv6",
         USEIPV6_TRUE);
     testcase1v6->SetStartTime(Seconds(1));
@@ -608,7 +608,7 @@
     //                     to be lost
     // How validated:  PingReport trace is checked for number of packets
     //                 transmitted (1) and received (0), and number of drops (0)
-    PingTestCase* testcase2v4 = new PingTestCase(
+    auto testcase2v4 = new PingTestCase(
         "2. Unlimited pings, no losses, StopApplication () with 1 packet in flight IPv4",
         USEIPV6_FALSE);
     testcase2v4->SetStartTime(Seconds(1));
@@ -619,7 +619,7 @@
     testcase1v4->SetDestinationAddress(Ipv4Address("10.0.0.2"));
     AddTestCase(testcase2v4, TestCase::QUICK);
 
-    PingTestCase* testcase2v6 = new PingTestCase(
+    auto testcase2v6 = new PingTestCase(
         "2. Unlimited pings, no losses, StopApplication () with 1 packet in flight IPv6",
         USEIPV6_TRUE);
     testcase2v6->SetStartTime(Seconds(1));
@@ -645,10 +645,9 @@
     //                 Report time will be MicroSeconds (2020001).
     uint32_t count = 2;
     uint32_t expectedTx = 2;
-    PingTestCase* testcase3v4 =
-        new PingTestCase("3. Test for operation of count attribute and exit "
-                         "time after all pings were received, IPv4",
-                         USEIPV6_FALSE);
+    auto testcase3v4 = new PingTestCase("3. Test for operation of count attribute and exit "
+                                        "time after all pings were received, IPv4",
+                                        USEIPV6_FALSE);
     testcase3v4->SetStartTime(Seconds(1));
     testcase3v4->SetStopTime(Seconds(5));
     testcase3v4->SetCount(count);
@@ -660,10 +659,9 @@
     testcase3v4->SetDestinationAddress(Ipv4Address("10.0.0.2"));
     AddTestCase(testcase3v4, TestCase::QUICK);
 
-    PingTestCase* testcase3v6 =
-        new PingTestCase("3. Test for operation of count attribute and exit "
-                         "time after all pings were received, IPv6",
-                         USEIPV6_TRUE);
+    auto testcase3v6 = new PingTestCase("3. Test for operation of count attribute and exit "
+                                        "time after all pings were received, IPv6",
+                                        USEIPV6_TRUE);
     testcase3v6->SetStartTime(Seconds(1));
     testcase3v6->SetStopTime(Seconds(5));
     testcase3v6->SetCount(count);
@@ -685,7 +683,7 @@
     // How validated:  PingReport trace is checked for number of packets
     //                 transmitted (2) and received (2), and number of drops (0)
     Time interval = Seconds(3.0);
-    PingTestCase* testcase4v4 =
+    auto testcase4v4 =
         new PingTestCase("4. Test for the operation of interval attribute for IPv4", USEIPV6_FALSE);
     testcase4v4->SetStartTime(Seconds(1));
     testcase4v4->SetStopTime(Seconds(5));
@@ -696,7 +694,7 @@
     testcase4v4->SetDestinationAddress(Ipv4Address("10.0.0.2"));
     AddTestCase(testcase4v4, TestCase::QUICK);
 
-    PingTestCase* testcase4v6 =
+    auto testcase4v6 =
         new PingTestCase("4. Test for the operation of interval attribute for IPv6", USEIPV6_TRUE);
     testcase4v6->SetStartTime(Seconds(1));
     testcase4v6->SetStopTime(Seconds(5));
@@ -724,7 +722,7 @@
     // How validated:  PingReport trace is checked for number of packets
     //                 transmitted (5) and  received (0).
     //                 The packet loss rate should be checked to be 100 percent
-    PingTestCase* testcase5v4 =
+    auto testcase5v4 =
         new PingTestCase("5. Test for behavior of ping to unreachable IPv4 address", USEIPV6_FALSE);
     testcase5v4->SetStartTime(Seconds(1));
     testcase5v4->SetStopTime(Seconds(5.5));
@@ -734,7 +732,7 @@
     testcase5v4->CheckReportLoss(100);
     AddTestCase(testcase5v4, TestCase::QUICK);
 
-    PingTestCase* testcase5v6 =
+    auto testcase5v6 =
         new PingTestCase("5. Test for behavior of ping to unreachable IPv6 address", USEIPV6_TRUE);
     testcase5v6->SetStartTime(Seconds(1));
     testcase5v6->SetStopTime(Seconds(5.5));
@@ -757,7 +755,7 @@
     // How validated:  PingReport trace is checked for number of packets
     //                 transmitted (2) and received (2),number of drops (0),
     //                 Report time will be MicroSeconds (2020001).
-    PingTestCase* testcase6v4 =
+    auto testcase6v4 =
         new PingTestCase("6. Test for behavior of ping to broadcast IPv4 address", USEIPV6_FALSE);
     testcase6v4->SetStartTime(Seconds(1));
     testcase6v4->SetStopTime(Seconds(5.5));
@@ -767,7 +765,7 @@
     testcase6v4->CheckReportLoss(0);
     AddTestCase(testcase6v4, TestCase::QUICK);
 
-    PingTestCase* testcase6v6 =
+    auto testcase6v6 =
         new PingTestCase("6. Test for behavior of ping to all-nodes multicast IPv6 address",
                          USEIPV6_TRUE);
     testcase6v6->SetStartTime(Seconds(1));
@@ -791,7 +789,7 @@
     //                 transmitted (3) and received (2), loss percentage (33).
     //                 Ping Tx trace (3) and Rtt trace (2) are also checked.
     //                 Report time will be MicroSeconds (3040000).
-    PingTestCase* testcase7v4 = new PingTestCase(
+    auto testcase7v4 = new PingTestCase(
         "7. Test behavior of first reply lost in a count-limited configuration, IPv4",
         USEIPV6_FALSE);
     std::list<uint32_t> dropList{0};
@@ -807,7 +805,7 @@
     testcase7v4->CheckReportTime(MicroSeconds(3040000));
     AddTestCase(testcase7v4, TestCase::QUICK);
 
-    PingTestCase* testcase7v6 = new PingTestCase(
+    auto testcase7v6 = new PingTestCase(
         "7. Test behavior of first reply lost in a count-limited configuration, IPv6",
         USEIPV6_TRUE);
     testcase7v6->SetDropList(dropList);
@@ -836,7 +834,7 @@
     //                 transmitted (3) and received (2), loss percentage (33).
     //                 Ping Tx trace (3) and Rtt trace (2) are also checked.
     //                 Report time will be MicroSeconds (3040000).
-    PingTestCase* testcase8v4 = new PingTestCase(
+    auto testcase8v4 = new PingTestCase(
         "8. Test behavior of second reply lost in a count-limited configuration, IPv4",
         USEIPV6_FALSE);
     std::list<uint32_t> dropList2{1};
@@ -852,7 +850,7 @@
     testcase8v4->CheckReportTime(MicroSeconds(3040000));
     AddTestCase(testcase8v4, TestCase::QUICK);
 
-    PingTestCase* testcase8v6 = new PingTestCase(
+    auto testcase8v6 = new PingTestCase(
         "8. Test behavior of second reply lost in a count-limited configuration, IPv6",
         USEIPV6_TRUE);
     testcase8v6->SetDropList(dropList2);
@@ -881,7 +879,7 @@
     //                 transmitted (3) and received (2), loss percentage (33).
     //                 Ping Tx trace (3) and Rtt trace (2) are also checked.
     //                 Report time will be MicroSeconds (3040000).
-    PingTestCase* testcase9v4 = new PingTestCase(
+    auto testcase9v4 = new PingTestCase(
         "9. Test behavior of last reply lost in a count-limited configuration, IPv4",
         USEIPV6_FALSE);
     std::list<uint32_t> dropList3{2};
@@ -897,7 +895,7 @@
     testcase9v4->CheckReportTime(MicroSeconds(3040000));
     AddTestCase(testcase9v4, TestCase::QUICK);
 
-    PingTestCase* testcase9v6 = new PingTestCase(
+    auto testcase9v6 = new PingTestCase(
         "9. Test behavior of last reply lost in a count-limited configuration, IPv6",
         USEIPV6_TRUE);
     testcase9v6->SetDropList(dropList3);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lr-wpan/examples/lr-wpan-bootstrap.cc ns-3.40/src/lr-wpan/examples/lr-wpan-bootstrap.cc
--- ns-3.39/src/lr-wpan/examples/lr-wpan-bootstrap.cc	2023-07-05 14:23:47.869427400 -0700
+++ ns-3.40/src/lr-wpan/examples/lr-wpan-bootstrap.cc	2023-09-27 13:30:37.670839000 -0700
@@ -381,7 +381,7 @@
     lrWpanHelper.SetExtendedAddresses(lrwpanDevices);
 
     // Devices hooks & MAC MLME-scan primitive set
-    for (NodeContainer::Iterator i = nodes.Begin(); i != nodes.End(); i++)
+    for (auto i = nodes.Begin(); i != nodes.End(); i++)
     {
         Ptr<Node> node = *i;
         Ptr<NetDevice> netDevice = node->GetDevice(0);
@@ -416,7 +416,7 @@
     }
 
     // Coordinator hooks
-    for (NodeContainer::Iterator i = coordinators.Begin(); i != coordinators.End(); i++)
+    for (auto i = coordinators.Begin(); i != coordinators.End(); i++)
     {
         Ptr<Node> coor = *i;
         Ptr<NetDevice> netDevice = coor->GetDevice(0);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lr-wpan/helper/lr-wpan-helper.cc ns-3.40/src/lr-wpan/helper/lr-wpan-helper.cc
--- ns-3.39/src/lr-wpan/helper/lr-wpan-helper.cc	2023-07-05 14:23:47.869427400 -0700
+++ ns-3.40/src/lr-wpan/helper/lr-wpan-helper.cc	2023-09-27 13:30:37.670839000 -0700
@@ -179,7 +179,7 @@
 LrWpanHelper::Install(NodeContainer c)
 {
     NetDeviceContainer devices;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); i++)
+    for (auto i = c.Begin(); i != c.End(); i++)
     {
         Ptr<Node> node = *i;
 
@@ -218,7 +218,7 @@
 {
     int64_t currentStream = stream;
     Ptr<NetDevice> netDevice;
-    for (NetDeviceContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         netDevice = (*i);
         Ptr<LrWpanNetDevice> lrwpan = DynamicCast<LrWpanNetDevice>(netDevice);
@@ -242,7 +242,7 @@
     Mac16Address coordShortAddr;
     Mac64Address coordExtAddr;
 
-    for (NetDeviceContainer::Iterator i = c.Begin(); i != c.End(); i++)
+    for (auto i = c.Begin(); i != c.End(); i++)
     {
         if (id < 0x0001 || id > 0xFFFD)
         {
@@ -285,7 +285,7 @@
     uint8_t idBuf[8] = {0, 0, 0, 0, 0, 0, 0, 0};
     Mac64Address address64;
 
-    for (NetDeviceContainer::Iterator i = c.Begin(); i != c.End(); i++)
+    for (auto i = c.Begin(); i != c.End(); i++)
     {
         Ptr<LrWpanNetDevice> device = DynamicCast<LrWpanNetDevice>(*i);
         if (device)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lr-wpan/model/lr-wpan-csmaca.h ns-3.40/src/lr-wpan/model/lr-wpan-csmaca.h
--- ns-3.39/src/lr-wpan/model/lr-wpan-csmaca.h	2023-07-05 14:23:47.869427400 -0700
+++ ns-3.40/src/lr-wpan/model/lr-wpan-csmaca.h	2023-09-27 13:30:37.670839000 -0700
@@ -23,8 +23,9 @@
 #ifndef LR_WPAN_CSMACA_H
 #define LR_WPAN_CSMACA_H
 
+#include "lr-wpan-mac.h"
+
 #include <ns3/event-id.h>
-#include <ns3/lr-wpan-mac.h>
 #include <ns3/object.h>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lr-wpan/model/lr-wpan-fields.cc ns-3.40/src/lr-wpan/model/lr-wpan-fields.cc
--- ns-3.39/src/lr-wpan/model/lr-wpan-fields.cc	2023-07-05 14:23:47.869427400 -0700
+++ ns-3.40/src/lr-wpan/model/lr-wpan-fields.cc	2023-09-27 13:30:37.670839000 -0700
@@ -492,25 +492,49 @@
     m_allocAddr = true;
 }
 
-uint32_t
-CapabilityField::GetSerializedSize() const
+CapabilityField::CapabilityField(uint8_t bitmap)
 {
-    return 1;
+    SetCapability(bitmap);
 }
 
-Buffer::Iterator
-CapabilityField::Serialize(Buffer::Iterator i) const
+uint8_t
+CapabilityField::GetCapability() const
 {
     uint8_t capability;
 
-    capability = 0;                                          //!< Bit 0 (reserved)
-    capability = (m_deviceType << 1) & (0x01 << 1);          //!< Bit 1
+    capability = (m_reservedBit0) & (0x01);                  //!< Bit 0 (reserved)
+    capability |= (m_deviceType << 1) & (0x01 << 1);         //!< Bit 1
     capability |= (m_powerSource << 2) & (0x01 << 2);        //!< Bit 2
     capability |= (m_receiverOnWhenIdle << 3) & (0x01 << 3); //!< Bit 3
-                                                             //!< Bit 4-5 (reserved)
+    capability |= (m_reservedBit45 << 4) & (0x03 << 4);      //!< Bit 4-5 (reserved)
     capability |= (m_securityCap << 6) & (0x01 << 6);        //!< Bit 6
     capability |= (m_allocAddr << 7) & (0x01 << 7);          //!< Bit 7
-    i.WriteU8(capability);
+
+    return capability;
+}
+
+void
+CapabilityField::SetCapability(uint8_t bitmap)
+{
+    m_reservedBit0 = (bitmap) & (0x01);            //!< Bit 0 (reserved)
+    m_deviceType = (bitmap >> 1) & (0x01);         //!< Bit 1
+    m_powerSource = (bitmap >> 2) & (0x01);        //!< Bit 2
+    m_receiverOnWhenIdle = (bitmap >> 3) & (0x01); //!< Bit 3
+    m_reservedBit45 = (bitmap >> 4) & (0x03);      //!< Bit 4-5 (reserved)
+    m_securityCap = (bitmap >> 6) & (0x01);        //!< Bit 6
+    m_allocAddr = (bitmap >> 7) & (0x01);          //!< Bit 7
+}
+
+uint32_t
+CapabilityField::GetSerializedSize() const
+{
+    return 1;
+}
+
+Buffer::Iterator
+CapabilityField::Serialize(Buffer::Iterator i) const
+{
+    i.WriteU8(GetCapability());
     return i;
 }
 
@@ -518,14 +542,7 @@
 CapabilityField::Deserialize(Buffer::Iterator i)
 {
     uint8_t capability = i.ReadU8();
-    //!< Bit 0 (reserved)
-    m_deviceType = (capability >> 1) & (0x01);         //!< Bit 1
-    m_powerSource = (capability >> 2) & (0x01);        //!< Bit 2
-    m_receiverOnWhenIdle = (capability >> 3) & (0x01); //!< Bit 3
-                                                       //!< Bit 4-5 (reserved)
-    m_securityCap = (capability >> 6) & (0x01);        //!< Bit 6
-    m_allocAddr = (capability >> 7) & (0x01);          //!< Bit 7
-
+    SetCapability(capability);
     return i;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lr-wpan/model/lr-wpan-fields.h ns-3.40/src/lr-wpan/model/lr-wpan-fields.h
--- ns-3.39/src/lr-wpan/model/lr-wpan-fields.h	2023-07-05 14:23:47.869427400 -0700
+++ ns-3.40/src/lr-wpan/model/lr-wpan-fields.h	2023-09-27 13:30:37.670839000 -0700
@@ -355,88 +355,137 @@
 {
   public:
     CapabilityField();
+
+    /**
+     * Construct a Capability field based on a bitmap.
+     *
+     * \param bitmap The bitmap representing the capability
+     */
+    CapabilityField(uint8_t bitmap);
+
+    /**
+     * Get the bitmap representing the device capability.
+     *
+     * \return The bitmap representing the device capability.
+     */
+    uint8_t GetCapability() const;
+
+    /**
+     * Set the bitmap representing the device capability.
+     *
+     * \param bitmap The bitmap representing the capability
+     */
+    void SetCapability(uint8_t bitmap);
+
     /**
      * Get the size of the serialized Capability Information Field.
+     *
      * \return the size of the serialized field.
      */
     uint32_t GetSerializedSize() const;
+
     /**
      * Serialize the entire Capability Information Field.
+     *
      * \param i an iterator which points to where the Capability information field
      * should be written.
      * \return an iterator.
      */
     Buffer::Iterator Serialize(Buffer::Iterator i) const;
+
     /**
      * Deserialize the entire Capability Information Field.
+     *
      * \param i an iterator which points to where the Capability information field should be read.
      * \return an iterator.
      */
     Buffer::Iterator Deserialize(Buffer::Iterator i);
+
     /**
      * True if the device type is a Full Functional Device (FFD) false if is a Reduced Functional
      * Device (RFD).
+     *
      * \return True if the device type is a Full Functional Device (FFD) false if is a Reduced
      * Functional Device (RFD).
      */
     bool IsDeviceTypeFfd() const;
+
     /**
      * True if the device is receiving power from alternating current mains.
+     *
      * \return True if the device is receiving power from alternating current mains.
      */
     bool IsPowSrcAvailable() const;
+
     /**
      * True if the device does not disable its receiver to conserve power during idle periods.
+     *
      * \return True if the device does not disable its receiver to conserve power during idle
      * periods.
      */
     bool IsReceiverOnWhenIdle() const;
+
     /**
      * True if the device is capable of sending and receiving cryptographically protected MAC
      * frames.
+     *
      * \return True if the device is capable of sending and receiving cryptographically protected
      * MAC frames.
      */
     bool IsSecurityCapability() const;
+
     /**
      * True if the device wishes the coordinator to allocate a short address as result of the
      * association procedure.
+     *
      * \return True if the device wishes the coordinator to allocate a short address as result of
      * the association procedure.
      */
     bool IsShortAddrAllocOn() const;
+
     /**
      * Set the Device type in the Capability Information Field.
      * True = full functional device (FFD)  False = reduced functional device (RFD).
+     *
      * \param devType The device type described in the Capability Information Field.
      */
     void SetFfdDevice(bool devType);
+
     /**
      * Set the Power Source available flag in the Capability Information Field.
+     *
      * \param pow Set true if a Power Source is available in the Capability Information Field.
      */
     void SetPowSrcAvailable(bool pow);
+
     /**
      * Indicate if the receiver is On on Idle
+     *
      * \param rxIdle Set true if the receiver is on when Idle
      */
     void SetRxOnWhenIdle(bool rxIdle);
+
     /**
      * Set the Security Capability flag in the Capability Information Field.
+     *
      * \param sec Set true if the device have Security Capabilities.
      */
     void SetSecurityCap(bool sec);
+
     /**
      * Set the Short Address Flag in the Capability Information Field.
+     *
      * \param addrAlloc Describes whether or not the coordinator should allocate a short
      *                  address in the association process.
      */
     void SetShortAddrAllocOn(bool addrAlloc);
 
   private:
+    bool m_reservedBit0;       //!< Capability Information Field, Reserved (bit 0)
     bool m_deviceType;         //!< Capability Information Field, Device Type  (bit 1)
     bool m_powerSource;        //!< Capability Information Field, Power Source (bit 2)
     bool m_receiverOnWhenIdle; //!< Capability Information Field, Receiver On When Idle (bit 3)
+    uint8_t m_reservedBit45;   //!< Capability Information Field, Reserved (bit 4 & 5)
     bool m_securityCap;        //!< Capability Information Field, Security Capability (bit 6)
     bool m_allocAddr;          //!< Capability Information Field, Allocate Address (bit 7)
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lr-wpan/model/lr-wpan-interference-helper.cc ns-3.40/src/lr-wpan/model/lr-wpan-interference-helper.cc
--- ns-3.39/src/lr-wpan/model/lr-wpan-interference-helper.cc	2023-07-05 14:23:47.869427400 -0700
+++ ns-3.40/src/lr-wpan/model/lr-wpan-interference-helper.cc	2023-09-27 13:30:37.670839000 -0700
@@ -95,9 +95,8 @@
     if (m_dirty)
     {
         // Sum up the current interference PSD.
-        std::set<Ptr<const SpectrumValue>>::const_iterator it;
         m_signal = Create<SpectrumValue>(m_spectrumModel);
-        for (it = m_signals.begin(); it != m_signals.end(); ++it)
+        for (auto it = m_signals.begin(); it != m_signals.end(); ++it)
         {
             *m_signal += *(*it);
         }
